 'Voor xx1216 tuner met MF 36.7 MHz (HRPT) OF 38.9 MHz (PDUS)
'Vergeet niet lpt portnummer en frequentiestap in te stellen
'Experimenteel programma van Arne van Belle   augustus 1997
'50 KHz stap


DECLARE SUB i2cstart ()
DECLARE FUNCTION i2creadlastbyte! ()
DECLARE FUNCTION i2cgetbyte! ()
DECLARE FUNCTION i2creadbyte! ()
DEFINT A-Z

DECLARE SUB initi2cbus ()
DECLARE SUB i2csetscl ()
DECLARE SUB i2cclearscl ()
DECLARE SUB i2csetsda ()
DECLARE SUB i2cclearsda ()
DECLARE SUB i2cstop ()
DECLARE SUB i2ctrck ()
'DECLARE FUNCTION i2creadbyte ()
'DECLARE FUNCTION i2creadlastbyte ()
DECLARE SUB i2ctrbyte (trbyte)


CONST lptbase = &H378  '&H378 voor LPT1, &H278 voor LPT2
CONST fstap = 50     '62.5 Khz bij 4 MHz Xtal, 50 KHz bij 3.2 MHz Xtal

CLS
CALL initi2cbus   ' optioneel eenmalig bij start van basic programma
                  'test op aanwezig zijn hardware / bus vrij
CALL i2cstart
CALL i2ctrbyte(192)  '11000000 is adres xx1216 als pin 15 aan gnd
ok = 0
DO
  INPUT "PDUS of HRPT ontvangst ? (P/H): "; mode$
 IF UCASE$(mode$) = "P" THEN
  mf = 389
  ok = 1
  PRINT "      PDUS ontvangst gekozen, MF=38.9 MHz"
 END IF

 IF UCASE$(mode$) = "H" THEN
  mf = 367
  ok = 1
  PRINT "      HRPT ontvangst gekozen, MF=36.7 MHz"
 END IF
LOOP WHILE ok = 0

DO
  INPUT "Geef frequentie op (134, 137.5, 141, 150 MHz): ", FREC$
  PRINT " Ingevoerd: "; FREC$
  INPUT "   Is dit juist ? (j/n)"; keus$
LOOP WHILE UCASE$(keus$) = "N"
 
  Fosc = 10 * VAL(FREC$) + mf
 PRINT "                                       Foscil.="; Fosc / 10
  deeltal = Fosc / fstap * 100
  b2 = 0
  b3 = 0
 PRINT "                                       Fstap  ="; fstap; "KHz"
 PRINT "                                       (Xtal  ="; .064 * fstap; " MHz)"
 PRINT "                                       Deeltal="; deeltal

IF deeltal - 16384 >= 0 THEN
   deeltal = deeltal - 16384
   b2 = 64
END IF
IF deeltal - 8192 >= 0 THEN
   deeltal = deeltal - 8192
   b2 = b2 + 32
END IF
IF deeltal - 4096 >= 0 THEN
   deeltal = deeltal - 4096
   b2 = b2 + 16
END IF
IF deeltal - 2048 >= 0 THEN
   deeltal = deeltal - 2048
   b2 = b2 + 8
END IF
IF deeltal - 1024 >= 0 THEN
   deeltal = deeltal - 1024
   b2 = b2 + 4
END IF
IF deeltal - 512 >= 0 THEN
   deeltal = deeltal - 512
   b2 = b2 + 2
END IF
IF deeltal - 256 >= 0 THEN
   deeltal = deeltal - 256
   b2 = b2 + 1
END IF
IF deeltal - 128 >= 0 THEN
   deeltal = deeltal - 128
   b3 = 128
END IF
IF deeltal - 64 >= 0 THEN
   deeltal = deeltal - 64
   b3 = b3 + 64
END IF
IF deeltal - 32 >= 0 THEN
   deeltal = deeltal - 32
   b3 = b3 + 32
END IF
IF deeltal - 16 >= 0 THEN
   deeltal = deeltal - 16
   b3 = b3 + 16
END IF
IF deeltal - 8 >= 0 THEN
   deeltal = deeltal - 8
   b3 = b3 + 8
END IF
IF deeltal - 4 >= 0 THEN
   deeltal = deeltal - 4
   b3 = b3 + 4
END IF
IF deeltal - 2 >= 0 THEN
   deeltal = deeltal - 2
   b3 = b3 + 2
END IF
IF deeltal - 1 >= 0 THEN
   deeltal = deeltal - 1
   b3 = b3 + 1
END IF
'Omzetting van deeltal naar byte2 en byte3            
'    byte2: 64   32   16   8    4    2   1
'deeltal: 16384+8192+4096+2048+1024+512+256+128+64+32+16+8+4+2+1
'    byte3:                                 128 64 32 16 8 4 2 1
CALL i2ctrbyte(b2)          'byte2
CALL i2ctrbyte(b3)         'byte3
CALL i2ctrbyte(128 + 8 + 4 )    'control info byte4 (50 KHz)
'CALL i2ctrbyte(64 + 32)           'control byte5: select LOW-BAND UV816
CALL i2ctrbyte(128 + 32)      'control byte5: select LOW-BAND xx1216
CALL i2cstop
ok = 0
tel = 0
DO
' Status byte van TSA5510 lezen                              
 CALL i2cstart
 CALL i2ctrbyte(193)  'dit is LEESadres TSA5510 (schrijfadres +1)
 status = i2creadlastbyte
 CALL i2cstop
 PRINT " Status byte TSA5511 is:", status
 tel = tel + 1
' IF status = 72 THEN
  IF status = 64 THEN
  PRINT " PLL is gelocked"
  ok = 1
 END IF
 IF tel > 250 THEN
  PRINT " PLL locked niet, controleer ingevoerde frequentie,"
  PRINT " en spanningen +5 +12 en +33V op tuner !"
  ok = 1
 END IF
LOOP UNTIL ok = 1

END
             
'De eerste keer status bit TSA5511 lezen na POR: MSB is altijd=1??
'Waarom is niet in Philips doc te vinden

'-IIC<--> LPT1 Base=378,
'        PC-lezen: Base+1 bit7&3 Bit3=SCL Bit3=SDA
'        PC-schrijven: Base bit7 Geinverteerd! =SDA
'                      Base+2 bit3 NIET geinverteerd! =SCL
' na PC-POR en boot staat er op I/O &H379  47 decimaal
' Op iic hardware na boot:SCL=1,SDA=0
'bij "call i2csetscl" direct gevolgd door "call i2cclearscl" wordt
'op 486-dx50/2 een puls van 20us breed geleverd.

SUB i2cclearscl
OUT (lptbase + 2), 228
END SUB

SUB i2cclearsda
OUT lptbase, 170
END SUB

DEFSNG A-Z
FUNCTION i2cgetbyte
dummy = 0     'initialize
FOR i = 7 TO 0 STEP -1   'msb first!
        CALL i2csetscl
        IF (INP(lptbase + 1) AND 2 ^ 7) THEN
        dummy = dummy + 2 ^ i
        END IF
        CALL i2cclearscl
NEXT i
i2cgetbyte = dummy
END FUNCTION

FUNCTION i2creadbyte
i2creadbyte = i2cgetbyte
'genereer acknowledge
CALL i2cclearsda        'SDA:0 =  acknowledge
CALL i2ctrck            'generate transmit klokpuls
CALL i2csetsda          'Laat SDA "vrij" om volgende byte te kunnen lezen
END FUNCTION

FUNCTION i2creadlastbyte
i2creadlastbyte = i2cgetbyte
'genereer geen acknowledge
CALL i2csetsda          'SDA:1 = no acknowledge
CALL i2ctrck            'generate transmit klokpuls
END FUNCTION

DEFINT A-Z
SUB i2csetscl
OUT (lptbase + 2), 236
 END SUB

SUB i2csetsda
OUT lptbase, 42
END SUB

DEFSNG A-Z
SUB i2cstart
CALL i2csetsda   'definieer begintoestand
CALL i2csetscl   'definieer begintoestand
CALL i2cclearsda   'Genereer start conditie
CALL i2cclearscl   'klok laag
END SUB

SUB i2cstop
CALL i2cclearsda        'maak SDA laag
CALL i2csetscl
CALL i2csetsda          '=stop conditie
END SUB

DEFINT A-Z
SUB i2ctrbyte (trbyte)
FOR i = 7 TO 0 STEP -1         'MSB's first
        IF (trbyte AND 2 ^ i) = 0 THEN
                CALL i2cclearsda
        ELSE
                CALL i2csetsda
        END IF           ' data bit staat nu op output
        CALL i2csetscl   'genereer klokpuls
        CALL i2cclearscl
NEXT i
'data transfer compleet, nu acknowledge ontvangen:
CALL i2csetsda          'SDA=1 : High-Z
CALL i2csetscl          'slave moet nu antwoorden met acknowledge
dummy = INP(lptbase + 1)
CALL i2cclearscl        'einde klokpuls
        IF (dummy AND 2 ^ 7) = 2 ^ 7 THEN
                PRINT "ERROR 002: subroutine -i2ctrbyte-"
                PRINT "NO ACKNOWLEDGE FROM SLAVE !!"
                END
        END IF
END SUB

DEFSNG A-Z
SUB i2ctrck
CALL i2csetscl    '0->1 flank
CALL i2cclearscl  '1->0 flank
END SUB

SUB initi2cbus
CALL i2csetscl
CALL i2csetsda
IF (INP(lptbase + 1) AND (2 ^ 7 + 2 ^ 3)) = (2 ^ 7 + 2 ^ 3) THEN
ELSE
CLS
PRINT "I2C Error 001 -initi2cbus"
PRINT "   Mogelijke oorzaken:"
PRINT "    1) I2C Hardware niet aanwezig op printer poort"
PRINT "    2) I2C Hardware +5 volt ontbreekt"
PRINT "    3) Slave houdt de bus vast (laag)"
END
END IF
END SUB

